import { Bounds } from './bounds';
export interface qTreeVecOptions {
    maxDepth?: number;
    maxChildren?: number;
}
export declare class BoundsVec<T extends object> {
    private boundsFn;
    private vector;
    private indexes;
    constructor(boundsFn: (item: T) => Bounds, initialCapacity: number);
    add(item: T): Bounds;
    get(item: T): Bounds;
    delete(item: T): void;
    clear(): void;
}
export declare class qTreeVec<T extends object> {
    private readonly depth;
    private readonly maxChildren;
    private readonly maxDepth;
    private readonly items;
    private readonly bounds;
    private readonly quadCache;
    private readonly childAreas;
    private readonly children;
    private isSplit;
    constructor([x0, y0, x1, y1]: Readonly<Bounds>, options: qTreeVecOptions, bounds: BoundsVec<T>, quadCache: WeakMap<T, qTreeVec<T>>, depth?: number);
    clear(): void;
    insert(item: Readonly<T>): void;
    remove(item: Readonly<T>): boolean;
    collectAll(result?: Readonly<T>[]): Readonly<T>[];
    collect(area: Readonly<Bounds>, result?: Readonly<T>[]): Readonly<T>[];
    all(): Generator<Readonly<T>, void, undefined>;
    search(area: Readonly<Bounds>): Generator<Readonly<T>, void, undefined>;
    size(): number;
    /** @internal */
    _remove(item: Readonly<T>): void;
    _insert(item: Readonly<T>, bounds: Bounds): void;
    private _tryInsertChild;
}
//# sourceMappingURL=q-tree-vec.d.ts.map